<?php

namespace \Losc\CucmBundle\Model\Webservice\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for XSubscribedService StructType
 * @subpackage Structs
 */
class XSubscribedService extends AbstractStructBase
{
    /**
     * The telecasterServiceName
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var \\Losc\CucmBundle\Model\Webservice\StructType\XFkType
     */
    public $telecasterServiceName;
    /**
     * The name
     * Meta information extracted from the WSDL
     * - base: xsd:string
     * - maxLength: 100
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var string
     */
    public $name;
    /**
     * The url
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $url;
    /**
     * The urlButtonIndex
     * Meta information extracted from the WSDL
     * - default: 0
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $urlButtonIndex;
    /**
     * The urlLabel
     * Meta information extracted from the WSDL
     * - base: xsd:string
     * - maxLength: 50
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $urlLabel;
    /**
     * The serviceNameAscii
     * Meta information extracted from the WSDL
     * - base: xsd:string
     * - maxLength: 50
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $serviceNameAscii;
    /**
     * Constructor method for XSubscribedService
     * @uses XSubscribedService::setTelecasterServiceName()
     * @uses XSubscribedService::setName()
     * @uses XSubscribedService::setUrl()
     * @uses XSubscribedService::setUrlButtonIndex()
     * @uses XSubscribedService::setUrlLabel()
     * @uses XSubscribedService::setServiceNameAscii()
     * @param \\Losc\CucmBundle\Model\Webservice\StructType\XFkType $telecasterServiceName
     * @param string $name
     * @param string $url
     * @param string $urlButtonIndex
     * @param string $urlLabel
     * @param string $serviceNameAscii
     */
    public function __construct(\\Losc\CucmBundle\Model\Webservice\StructType\XFkType $telecasterServiceName = null, $name = null, $url = null, $urlButtonIndex = '0', $urlLabel = null, $serviceNameAscii = null)
    {
        $this
            ->setTelecasterServiceName($telecasterServiceName)
            ->setName($name)
            ->setUrl($url)
            ->setUrlButtonIndex($urlButtonIndex)
            ->setUrlLabel($urlLabel)
            ->setServiceNameAscii($serviceNameAscii);
    }
    /**
     * Get telecasterServiceName value
     * @return \\Losc\CucmBundle\Model\Webservice\StructType\XFkType
     */
    public function getTelecasterServiceName()
    {
        return $this->telecasterServiceName;
    }
    /**
     * Set telecasterServiceName value
     * @param \\Losc\CucmBundle\Model\Webservice\StructType\XFkType $telecasterServiceName
     * @return \\Losc\CucmBundle\Model\Webservice\StructType\XSubscribedService
     */
    public function setTelecasterServiceName(\\Losc\CucmBundle\Model\Webservice\StructType\XFkType $telecasterServiceName = null)
    {
        $this->telecasterServiceName = $telecasterServiceName;
        return $this;
    }
    /**
     * Get name value
     * @return string
     */
    public function getName()
    {
        return $this->name;
    }
    /**
     * Set name value
     * @param string $name
     * @return \\Losc\CucmBundle\Model\Webservice\StructType\XSubscribedService
     */
    public function setName($name = null)
    {
        $this->name = $name;
        return $this;
    }
    /**
     * Get url value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getUrl()
    {
        return isset($this->url) ? $this->url : null;
    }
    /**
     * Set url value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $url
     * @return \\Losc\CucmBundle\Model\Webservice\StructType\XSubscribedService
     */
    public function setUrl($url = null)
    {
        if (is_null($url) || (is_array($url) && empty($url))) {
            unset($this->url);
        } else {
            $this->url = $url;
        }
        return $this;
    }
    /**
     * Get urlButtonIndex value
     * @return string|null
     */
    public function getUrlButtonIndex()
    {
        return $this->urlButtonIndex;
    }
    /**
     * Set urlButtonIndex value
     * @param string $urlButtonIndex
     * @return \\Losc\CucmBundle\Model\Webservice\StructType\XSubscribedService
     */
    public function setUrlButtonIndex($urlButtonIndex = '0')
    {
        $this->urlButtonIndex = $urlButtonIndex;
        return $this;
    }
    /**
     * Get urlLabel value
     * @return string|null
     */
    public function getUrlLabel()
    {
        return $this->urlLabel;
    }
    /**
     * Set urlLabel value
     * @param string $urlLabel
     * @return \\Losc\CucmBundle\Model\Webservice\StructType\XSubscribedService
     */
    public function setUrlLabel($urlLabel = null)
    {
        $this->urlLabel = $urlLabel;
        return $this;
    }
    /**
     * Get serviceNameAscii value
     * @return string|null
     */
    public function getServiceNameAscii()
    {
        return $this->serviceNameAscii;
    }
    /**
     * Set serviceNameAscii value
     * @param string $serviceNameAscii
     * @return \\Losc\CucmBundle\Model\Webservice\StructType\XSubscribedService
     */
    public function setServiceNameAscii($serviceNameAscii = null)
    {
        $this->serviceNameAscii = $serviceNameAscii;
        return $this;
    }
}
